//
// ******************************  Question 1 **************************************
//  
// The function Max is supposed to calculate the maximal number in an array,
// but does not fulfil its specification. Namely, if you compile, Dafny will
// give you error messages. Fix the definition, without changing the pre- and
// post-conditions so that the specification can be verified by Dafny. 

method max(a: array<int>) returns (max: nat)
  requires a != null && a.Length > 0;
  requires forall j:: 0<=j<a.Length ==> a[j] >= 0;
  ensures forall j:: 0<=j<a.Length ==> a[j] <= max;
  ensures exists j:: 0<=j<a.Length && a[j]==max;
{
  max := 0;
  var i := 0;

  while (i < a.Length)
    invariant 0 <= i <= a.Length;
    invariant forall j:: 0<=j<i ==> a[j] <= max;
    invariant i!=0 ==> exists j:: 0<=j<i && a[j]==max;
    invariant i==0 ==> a[0] >= max;
{
 	if (a[i] > max) {
	  max := a[i]; 
    }
     i := i + 1;
  }
}
